diff --git a/src/backend/executor/execTuples.c b/src/backend/executor/execTuples.c
index 7ae70a8..fabb628 100644
--- a/src/backend/executor/execTuples.c
+++ b/src/backend/executor/execTuples.c
@@ -116,6 +116,7 @@ MakeTupleTableSlot(void)
 	slot->tts_shouldFree = false;
 	slot->tts_shouldFreeMin = false;
 	slot->tts_tuple = NULL;
+	ItemPointerSetInvalid(&(slot->tts_tid));
 	slot->tts_tupleDescriptor = NULL;
 	slot->tts_mcxt = CurrentMemoryContext;
 	slot->tts_buffer = InvalidBuffer;
@@ -369,6 +370,8 @@ ExecStoreTuple(HeapTuple tuple,
 			IncrBufferRefCount(buffer);
 	}
 
+	ItemPointerCopy(&(tuple->t_self), &(slot->tts_tid));
+
 	return slot;
 }
 
@@ -427,6 +430,63 @@ ExecStoreMinimalTuple(MinimalTuple mtup,
 	return slot;
 }
 
+/*
+ * heap_modify_slot_by_cols
+ *		form a new tuple from an old tuple and a set of replacement values.
+ *
+ * This is like heap_modify_tuple, except that instead of specifying which
+ * column(s) to replace by a boolean map, an array of target column numbers
+ * is used.  This is often more convenient when a fixed number of columns
+ * are to be replaced.  The replCols, replValues, and replIsnull arrays must
+ * be of length nCols.  Target column numbers are indexed from 1.
+ *
+ * The result is allocated in the current memory context.
+ */
+TupleTableSlot*
+heap_modify_slot_by_cols(TupleTableSlot *slot,
+						 int nCols,
+						 int *replCols,
+						 Datum *replValues,
+						 bool *replIsnull)
+{
+	int			numberOfAttributes = slot->tts_tupleDescriptor->natts;
+	HeapTuple	newTuple;
+	int			i;
+
+	slot_getallattrs(slot);
+
+	for (i = 0; i < nCols; i++)
+	{
+		int			attnum = replCols[i];
+
+		if (attnum <= 0 || attnum > numberOfAttributes)
+			elog(ERROR, "invalid column number %d", attnum);
+		slot->tts_values[attnum - 1] = replValues[i];
+		slot->tts_isnull[attnum - 1] = replIsnull[i];
+	}
+
+	/*
+	 * create a new tuple from the values and isnull arrays
+	 */
+	newTuple = heap_form_tuple(slot->tts_tupleDescriptor, slot->tts_values, slot->tts_isnull);
+
+	/*
+	 * copy the identification info of the old tuple: t_ctid, t_self, and OID
+	 * (if any)
+	 */
+	newTuple->t_data->t_ctid = slot->tts_tuple->t_data->t_ctid;
+	newTuple->t_self = slot->tts_tuple->t_self;
+	newTuple->t_tableOid = slot->tts_tuple->t_tableOid;
+	if (slot->tts_tupleDescriptor->tdhasoid)
+		HeapTupleSetOid(newTuple, HeapTupleGetOid(slot->tts_tuple));
+
+	if (slot->tts_shouldFree)
+		heap_freetuple(slot->tts_tuple);
+
+	slot->tts_tuple = newTuple;
+	return slot;
+}
+
 /* --------------------------------
  *		ExecClearTuple
  *
diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index 8d17425..387c059 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -557,6 +557,7 @@ ExecInsert(ModifyTableState *mtstate,
 								HEAP_INSERT_SPECULATIVE,
 								NULL);
 
+			ItemPointerCopy(&(tuple->t_self), &(slot->tts_tid));
 			/* insert index entries for tuple */
 			recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
 												   estate, true, &specConflict,
@@ -602,6 +603,7 @@ ExecInsert(ModifyTableState *mtstate,
 								estate->es_output_cid,
 								0, NULL);
 
+			ItemPointerCopy(&(tuple->t_self), &(slot->tts_tid));
 			/* insert index entries for tuple */
 			if (resultRelInfo->ri_NumIndices > 0)
 				recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
@@ -618,7 +620,7 @@ ExecInsert(ModifyTableState *mtstate,
 	}
 
 	/* AFTER ROW INSERT Triggers */
-	ExecARInsertTriggers(estate, resultRelInfo, tuple, recheckIndexes,
+	ExecARInsertTriggers(estate, resultRelInfo, slot, recheckIndexes,
 						 mtstate->mt_transition_capture);
 
 	list_free(recheckIndexes);
@@ -669,7 +671,7 @@ ExecInsert(ModifyTableState *mtstate,
 static TupleTableSlot *
 ExecDelete(ModifyTableState *mtstate,
 		   ItemPointer tupleid,
-		   HeapTuple oldtuple,
+		   TupleTableSlot *oldslot,
 		   TupleTableSlot *planSlot,
 		   EPQState *epqstate,
 		   EState *estate,
@@ -694,7 +696,7 @@ ExecDelete(ModifyTableState *mtstate,
 		bool		dodelete;
 
 		dodelete = ExecBRDeleteTriggers(estate, epqstate, resultRelInfo,
-										tupleid, oldtuple);
+										tupleid, oldslot);
 
 		if (!dodelete)			/* "do nothing" */
 			return NULL;
@@ -706,8 +708,8 @@ ExecDelete(ModifyTableState *mtstate,
 	{
 		bool		dodelete;
 
-		Assert(oldtuple != NULL);
-		dodelete = ExecIRDeleteTriggers(estate, resultRelInfo, oldtuple);
+		Assert(oldslot != NULL);
+		dodelete = ExecIRDeleteTriggers(estate, resultRelInfo, oldslot);
 
 		if (!dodelete)			/* "do nothing" */
 			return NULL;
@@ -844,8 +846,11 @@ ldelete:;
 	if (canSetTag)
 		(estate->es_processed)++;
 
+	if (oldslot != NULL)
+		ItemPointerCopy(tupleid, &(oldslot->tts_tid));
+
 	/* AFTER ROW DELETE Triggers */
-	ExecARDeleteTriggers(estate, resultRelInfo, tupleid, oldtuple,
+	ExecARDeleteTriggers(estate, resultRelInfo, tupleid, oldslot,
 						 mtstate->mt_transition_capture);
 
 	/* Process RETURNING if present */
@@ -868,10 +873,12 @@ ldelete:;
 		else
 		{
 			slot = estate->es_trig_tuple_slot;
-			if (oldtuple != NULL)
+			if (oldslot != NULL)
 			{
-				deltuple = *oldtuple;
-				delbuffer = InvalidBuffer;
+				ExecCopySlot(slot, oldslot);
+
+				if (slot->tts_tupleDescriptor != RelationGetDescr(resultRelationDesc))
+					ExecSetSlotDescriptor(slot, RelationGetDescr(resultRelationDesc));
 			}
 			else
 			{
@@ -879,11 +886,11 @@ ldelete:;
 				if (!heap_fetch(resultRelationDesc, SnapshotAny,
 								&deltuple, &delbuffer, false, NULL))
 					elog(ERROR, "failed to fetch deleted tuple for DELETE RETURNING");
-			}
 
-			if (slot->tts_tupleDescriptor != RelationGetDescr(resultRelationDesc))
-				ExecSetSlotDescriptor(slot, RelationGetDescr(resultRelationDesc));
-			ExecStoreTuple(&deltuple, slot, InvalidBuffer, false);
+				if (slot->tts_tupleDescriptor != RelationGetDescr(resultRelationDesc))
+					ExecSetSlotDescriptor(slot, RelationGetDescr(resultRelationDesc));
+				ExecStoreTuple(&deltuple, slot, InvalidBuffer, false);
+			}
 		}
 
 		rslot = ExecProcessReturning(resultRelInfo, slot, planSlot);
@@ -929,7 +936,7 @@ ldelete:;
 static TupleTableSlot *
 ExecUpdate(ModifyTableState *mtstate,
 		   ItemPointer tupleid,
-		   HeapTuple oldtuple,
+		   TupleTableSlot *oldslot,
 		   TupleTableSlot *slot,
 		   TupleTableSlot *planSlot,
 		   EPQState *epqstate,
@@ -966,7 +973,7 @@ ExecUpdate(ModifyTableState *mtstate,
 		resultRelInfo->ri_TrigDesc->trig_update_before_row)
 	{
 		slot = ExecBRUpdateTriggers(estate, epqstate, resultRelInfo,
-									tupleid, oldtuple, slot);
+									tupleid, oldslot, slot);
 
 		if (slot == NULL)		/* "do nothing" */
 			return NULL;
@@ -980,7 +987,7 @@ ExecUpdate(ModifyTableState *mtstate,
 		resultRelInfo->ri_TrigDesc->trig_update_instead_row)
 	{
 		slot = ExecIRUpdateTriggers(estate, resultRelInfo,
-									oldtuple, slot);
+									oldslot, slot);
 
 		if (slot == NULL)		/* "do nothing" */
 			return NULL;
@@ -1138,6 +1145,7 @@ lreplace:;
 		 * All we do here is insert new index tuples.  -cim 9/27/89
 		 */
 
+		ItemPointerCopy(&(tuple->t_self), &(slot->tts_tid));
 		/*
 		 * insert index entries for tuple
 		 *
@@ -1155,7 +1163,7 @@ lreplace:;
 		(estate->es_processed)++;
 
 	/* AFTER ROW UPDATE Triggers */
-	ExecARUpdateTriggers(estate, resultRelInfo, tupleid, oldtuple, tuple,
+	ExecARUpdateTriggers(estate, resultRelInfo, tupleid, oldslot, slot,
 						 recheckIndexes,
 						 mtstate->mt_transition_capture);
 
@@ -1550,6 +1558,7 @@ ExecModifyTable(ModifyTableState *node)
 	ItemPointerData tuple_ctid;
 	HeapTupleData oldtupdata;
 	HeapTuple	oldtuple;
+	TupleTableSlot *oldslot = NULL;
 
 	/*
 	 * This should NOT get called during EvalPlanQual; we should have passed a
@@ -1659,7 +1668,8 @@ ExecModifyTable(ModifyTableState *node)
 		}
 
 		EvalPlanQualSetSlot(&node->mt_epqstate, planSlot);
-		slot = planSlot;
+		slot = MakeSingleTupleTableSlot(planSlot->tts_tupleDescriptor);
+		ExecCopySlot(slot, planSlot);
 
 		oldtuple = NULL;
 		if (junkfilter != NULL)
@@ -1721,6 +1731,10 @@ ExecModifyTable(ModifyTableState *node)
 						RelationGetRelid(resultRelInfo->ri_RelationDesc);
 
 					oldtuple = &oldtupdata;
+
+					ItemPointerCopy(tupleid, &(oldslot->tts_tid));
+					oldslot = MakeSingleTupleTableSlot(RelationGetDescr(resultRelInfo->ri_RelationDesc));
+					ExecStoreTuple(oldtuple, oldslot, InvalidBuffer, false);
 				}
 				else
 					Assert(relkind == RELKIND_FOREIGN_TABLE);
@@ -1741,11 +1755,11 @@ ExecModifyTable(ModifyTableState *node)
 								  estate, node->canSetTag);
 				break;
 			case CMD_UPDATE:
-				slot = ExecUpdate(node, tupleid, oldtuple, slot, planSlot,
+				slot = ExecUpdate(node, tupleid, oldslot, slot, planSlot,
 								  &node->mt_epqstate, estate, node->canSetTag);
 				break;
 			case CMD_DELETE:
-				slot = ExecDelete(node, tupleid, oldtuple, planSlot,
+				slot = ExecDelete(node, tupleid, oldslot, planSlot,
 								  &node->mt_epqstate, estate, node->canSetTag);
 				break;
 			default:
@@ -1753,6 +1767,9 @@ ExecModifyTable(ModifyTableState *node)
 				break;
 		}
 
+		if (oldslot)
+			ExecDropSingleTupleTableSlot(oldslot);
+
 		/*
 		 * If we got a RETURNING result, return it to caller.  We'll continue
 		 * the work on next call.
diff --git a/src/backend/executor/spi.c b/src/backend/executor/spi.c
index cd00a6d..79ffa52 100644
--- a/src/backend/executor/spi.c
+++ b/src/backend/executor/spi.c
@@ -23,6 +23,7 @@
 #include "commands/trigger.h"
 #include "executor/executor.h"
 #include "executor/spi_priv.h"
+#include "executor/tuptable.h"
 #include "miscadmin.h"
 #include "tcop/pquery.h"
 #include "tcop/utility.h"
@@ -757,6 +758,72 @@ SPI_modifytuple(Relation rel, HeapTuple tuple, int natts, int *attnum,
 	return mtuple;
 }
 
+TupleTableSlot *
+SPI_modifyslot(TupleTableSlot *slot, int natts, int *attnum,
+				Datum *Values, const char *Nulls)
+{
+	MemoryContext oldcxt;
+	HeapTuple	mtuple;
+	int			numberOfAttributes;
+	int			i;
+
+	if (slot == NULL || natts < 0 || attnum == NULL || Values == NULL)
+	{
+		SPI_result = SPI_ERROR_ARGUMENT;
+		return NULL;
+	}
+
+	if (_SPI_current == NULL)
+	{
+		SPI_result = SPI_ERROR_UNCONNECTED;
+		return NULL;
+	}
+
+	oldcxt = MemoryContextSwitchTo(_SPI_current->savedcxt);
+
+	SPI_result = 0;
+
+	numberOfAttributes = slot->tts_tupleDescriptor->natts;
+
+	/* replace values and nulls */
+	for (i = 0; i < natts; i++)
+	{
+		if (attnum[i] <= 0 || attnum[i] > numberOfAttributes)
+			break;
+		slot->tts_values[attnum[i] - 1] = Values[i];
+		slot->tts_isnull[attnum[i] - 1] = (Nulls && Nulls[i] == 'n') ? true : false;
+	}
+
+	if (i == natts)				/* no errors in *attnum */
+	{
+		mtuple = heap_form_tuple(slot->tts_tupleDescriptor, slot->tts_values, slot->tts_isnull);
+
+		/*
+		 * copy the identification info of the old tuple: t_ctid, t_self, and
+		 * OID (if any)
+		 */
+		mtuple->t_data->t_ctid = slot->tts_tuple->t_data->t_ctid;
+		mtuple->t_self = slot->tts_tuple->t_self;
+		mtuple->t_tableOid = slot->tts_tuple->t_tableOid;
+		if (slot->tts_tupleDescriptor->tdhasoid)
+			HeapTupleSetOid(mtuple, HeapTupleGetOid(slot->tts_tuple));
+	}
+	else
+	{
+		mtuple = NULL;
+		SPI_result = SPI_ERROR_NOATTRIBUTE;
+	}
+
+	MemoryContextSwitchTo(oldcxt);
+
+	if (slot->tts_shouldFree)
+		heap_freetuple(slot->tts_tuple);
+
+	slot->tts_tuple = mtuple;
+
+	return slot;
+}
+
 int
 SPI_fnumber(TupleDesc tupdesc, const char *fname)
 {
@@ -801,7 +868,7 @@ SPI_fname(TupleDesc tupdesc, int fnumber)
 }
 
 char *
-SPI_getvalue(HeapTuple tuple, TupleDesc tupdesc, int fnumber)
+SPI_getvalue(TupleTableSlot *slot, int fnumber)
 {
 	Datum		val;
 	bool		isnull;
@@ -811,19 +878,19 @@ SPI_getvalue(HeapTuple tuple, TupleDesc tupdesc, int fnumber)
 
 	SPI_result = 0;
 
-	if (fnumber > tupdesc->natts || fnumber == 0 ||
+	if (fnumber > slot->tts_tupleDescriptor->natts || fnumber == 0 ||
 		fnumber <= FirstLowInvalidHeapAttributeNumber)
 	{
 		SPI_result = SPI_ERROR_NOATTRIBUTE;
 		return NULL;
 	}
 
-	val = heap_getattr(tuple, fnumber, tupdesc, &isnull);
+	val = slot_getattr(slot, fnumber, &isnull);
 	if (isnull)
 		return NULL;
 
 	if (fnumber > 0)
-		typoid = tupdesc->attrs[fnumber - 1]->atttypid;
+		typoid = slot->tts_tupleDescriptor->attrs[fnumber - 1]->atttypid;
 	else
 		typoid = (SystemAttributeDefinition(fnumber, true))->atttypid;
 
@@ -833,11 +900,11 @@ SPI_getvalue(HeapTuple tuple, TupleDesc tupdesc, int fnumber)
 }
 
 Datum
-SPI_getbinval(HeapTuple tuple, TupleDesc tupdesc, int fnumber, bool *isnull)
+SPI_getbinval(TupleTableSlot *slot, int fnumber, bool *isnull)
 {
 	SPI_result = 0;
 
-	if (fnumber > tupdesc->natts || fnumber == 0 ||
+	if (fnumber > slot->tts_tupleDescriptor->natts || fnumber == 0 ||
 		fnumber <= FirstLowInvalidHeapAttributeNumber)
 	{
 		SPI_result = SPI_ERROR_NOATTRIBUTE;
@@ -845,7 +912,7 @@ SPI_getbinval(HeapTuple tuple, TupleDesc tupdesc, int fnumber, bool *isnull)
 		return (Datum) NULL;
 	}
 
-	return heap_getattr(tuple, fnumber, tupdesc, isnull);
+	return slot_getattr(slot, fnumber, isnull);
 }
 
 char *
@@ -1681,7 +1748,7 @@ spi_dest_startup(DestReceiver *self, int operation, TupleDesc typeinfo)
 
 	/* set up initial allocations */
 	tuptable->alloced = tuptable->free = 128;
-	tuptable->vals = (HeapTuple *) palloc(tuptable->alloced * sizeof(HeapTuple));
+	tuptable->vals = (TupleTableSlot **) palloc(tuptable->alloced * sizeof(TupleTableSlot *));
 	tuptable->tupdesc = CreateTupleDescCopy(typeinfo);
 
 	MemoryContextSwitchTo(oldcxt);
@@ -1697,6 +1764,7 @@ spi_printtup(TupleTableSlot *slot, DestReceiver *self)
 {
 	SPITupleTable *tuptable;
 	MemoryContext oldcxt;
+	TupleTableSlot *dstslot;
 
 	if (_SPI_current == NULL)
 		elog(ERROR, "spi_printtup called while not connected to SPI");
@@ -1712,12 +1780,12 @@ spi_printtup(TupleTableSlot *slot, DestReceiver *self)
 		/* Double the size of the pointer array */
 		tuptable->free = tuptable->alloced;
 		tuptable->alloced += tuptable->free;
-		tuptable->vals = (HeapTuple *) repalloc_huge(tuptable->vals,
-													 tuptable->alloced * sizeof(HeapTuple));
+		tuptable->vals = (TupleTableSlot **) repalloc_huge(tuptable->vals,
+									  tuptable->alloced * sizeof(TupleTableSlot *));
 	}
 
-	tuptable->vals[tuptable->alloced - tuptable->free] =
-		ExecCopySlotTuple(slot);
+	dstslot = MakeSingleTupleTableSlot(tuptable->tupdesc);
+	tuptable->vals[tuptable->alloced - tuptable->free] = ExecCopySlot(dstslot, slot);
 	(tuptable->free)--;
 
 	MemoryContextSwitchTo(oldcxt);
diff --git a/src/backend/replication/logical/worker.c b/src/backend/replication/logical/worker.c
index 0d48dfa..4a01fbd 100644
--- a/src/backend/replication/logical/worker.c
+++ b/src/backend/replication/logical/worker.c
@@ -726,6 +726,7 @@ apply_handle_update(StringInfo s)
 		/* Process and store remote tuple in the slot */
 		oldctx = MemoryContextSwitchTo(GetPerTupleMemoryContext(estate));
 		ExecStoreTuple(localslot->tts_tuple, remoteslot, InvalidBuffer, false);
+		ItemPointerCopy(&(localslot->tts_tuple->t_self), &(remoteslot->tts_tid));
 		slot_modify_cstrings(remoteslot, rel, newtup.values, newtup.changed);
 		MemoryContextSwitchTo(oldctx);
 
